#include <string.h>
#include <errno.h>

#include "asap.h"

char           *ASAPerrorText(status)
    ASAPstatus_t    status;
{
    switch (status) {
    case ASAP_ENOSUCHSERV:
	return ("no such server found");
    case ASAP_ESYNTAX:
	return ("syntax error in server database file");
    case ASAP_ENODBFILE:
	return ("no database file found");
    case ASAP_EBADTYPE:
	return ("token type does not match");
    case ASAP_ESYS:
	return ("system error");
    case ASAP_ENOPORT:
	return ("no free communication port found");
    case ASAP_BROKEN:
	return ("connection broken");
    default:
	return ("unknown (or lost) error");
    }
}


void           *ASAPperror(status, msg)
    char           *msg;
    ASAPstatus_t    status;
{
    char            buf[1024];
    char           *asaperror;
    int             alen;
    extern char    *sys_errlist[];

    asaperror = ASAPerrorText(status);

    write(2, msg, strlen(msg));
    write(2, " : ", strlen(" : "));
    write(2, asaperror, strlen(asaperror));
    if (status == ASAP_ESYS) {
	write(2, "(", 1);
	/* we should protect ourselves from "errno" > "sys_nerr" ... */
	write(2, sys_errlist[errno], strlen(sys_errlist[errno]));
	write(2, ")", 1);
    }
    write(2, "\n", 1);
}
