#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <malloc.h>
#include <stdlib.h>

#include "myAll.h"
#include "myMisc.h"





/* do nothing... usefull when a function pointer is needed */
void            nullFunc(void)
{
}


/* convert a Byte into it's binary form (a string with 0 and 1) */
/* just change char into the desired type */
/* don't work with types with size > sizeof(long) */
char           *charToBit(char w)
{
    unsigned long   mask = 1;
    unsigned long   tw = (unsigned long) w;
    char           *rep;
    char           *pt, c;
    int             len, pak, i;

    len = sizeof(char) * 8;	/* just change char in the desired type */
    len += len / 4 - 1;
    rep = (char *) malloc(len + 1);
    rep[len] = '\0';
    pt = rep + len;
    pak = 0;
    for (i = 0; i < sizeof(int) * 8; i++) {
	c = (tw & mask) ? '1' : '0';
	mask <<= 1;
	*pt = c;
	pt--;
	pak++;
	if (pak == 4) {
	    pak = 0;
	    *pt = ' ';
	    pt--;
	}
    }
    while (pt >= rep) {
	*pt = ' ';
	pt--;
    }
    return rep;
}


char           *intToBit(int w)
{
    unsigned long   mask = 1;
    unsigned long   tw = (unsigned long) w;
    char           *rep;
    char           *pt, c;
    int             len, pak, i;

    len = sizeof(int) * 8;
    len += len / 4 - 1;
    rep = (char *) malloc(len + 1);
    rep[len] = '\0';
    pt = rep + len;
    pak = 0;
    for (i = 0; i < sizeof(int) * 8; i++) {
	c = (tw & mask) ? '1' : '0';
	mask <<= 1;
	*pt = c;
	pt--;
	pak++;
	if (pak == 4) {
	    pak = 0;
	    *pt = ' ';
	    pt--;
	}
    }
    while (pt >= rep) {
	*pt = ' ';
	pt--;
    }
    return rep;
}



/* sprint the diference between times st and et (StartTime and EndTime) */
/* s must have been alocated before */
void            sprintTime(char *s, void *st, void *et)
{
    printf("%s :%8d ms\n", s, difTime(st, et));
}


/* compute the time diference between times st and et (StartTime and EndTime) */
int             difTime(struct timeb * st, struct timeb * et)
{
    return (et->time * 1000 + et->millitm) - (st->time * 1000 + st->millitm);
}



void            indent(char *com)
{
    static char    *spaces = NULL;
    static int      nbSpaces = 0;
    static int      level;
    char           *c, *comb;
    int             i;


    if (com == (char *) NULL)
	com = "p";
    comb = myStrDup(com);
    while ((c = strchr(comb, '+')) != (char *) NULL) {
	*c = ' ';
	level++;
    }
    while ((c = strchr(comb, '-')) != (char *) NULL) {
	*c = ' ';
	level--;
    }
    if (level < 0)
	error("indent: level <0!");
    if ((c = strchr(comb, 'p')) != (char *) NULL) {
	*c = ' ';
	if ((nbSpaces < level * INDENT_TAB) || (spaces == (char *) NULL)) {
	    nbSpaces = level * INDENT_TAB + 4 * INDENT_TAB;
	    if (spaces != (char *) NULL)
		free(spaces);
	    spaces = (char *) myMalloc(nbSpaces + 1);
	    for (i = 0; i < nbSpaces; i++)
		spaces[i] = ' ';
	    spaces[nbSpaces] = '\0';
	}
	putchar('\n');
	fputs(&spaces[nbSpaces - level * INDENT_TAB], stdout);
    }
    free(comb);
}


/* check if file named 'n' exist with mod 'p' */
/* p is a string containing :                 */
/* x-> execute   */
/* r-> read      */
/* w-> write     */
/* d-> directory */
Boolean         fileExist(char *n, char *p)
{
    int             status;
    struct stat     buf;

    status = stat(n, &buf);

    if (strchr(p, 'x')) {
	if (!(buf.st_mode & S_IXUSR))
	    return False;
    }
    if (strchr(p, 'r')) {
	if (!(buf.st_mode & S_IRUSR))
	    return False;
    }
    if (strchr(p, 'w')) {
	if (!(buf.st_mode & S_IWUSR))
	    return False;
    }
    if (strchr(p, 'd')) {
	if (!S_ISDIR(buf.st_mode))
	    return False;
    }
    return True;
}


char           *argvToStr(char **argv)
{
    int             nbc = 0;
    char          **pps;
    char           *s, *ps;

    pps = argv;
    while (*pps) {
	nbc += strlen(*pps);
	pps++;
    }
    s = myMalloc(sizeof(char) * (nbc + 1));
    ps = s;
    pps = argv;
    while (*pps) {
	strcpy(ps, *pps);
	ps += strlen(*pps);
	pps++;
    }
    return s;
}


/***************************************************************************/
/* get some string parameter out of argv                                   */
/* param                                                                   */
/* pargc  : pointer on argc                                                */
/* pargv  :  "         argv                                                */
/* post                                                                    */
/* string : if success allocated and filled with the parameter             */
/* argc and argv are modified due to the match found                       */
/* return                                                                  */
/* OK  or Err                                                              */
int             getStringParam(int *pargc, char ***pargv, char **string)
{
    if ((**pargv)[2] != '\0') {	/* like -sname */
	*string = (char *) myMalloc(sizeof(char) * (1 + strlen(&((**pargv)[2]))));
	strcpy(*string, &((**pargv)[2]));
	(*pargv)++;		/* forget the '-sname' */
	(*pargc)--;
	return Ok;
    }
    else {			/* like -s name */
	(*pargv)++;		/* forget the '-s' */
	(*pargc)--;
	if (*pargc <= 0)
	    return Err;
	if ((**pargv)[0] != '-') {
	    *string = (char *) myMalloc(sizeof(char) * (1 + strlen(**pargv)));
	    strcpy(*string, **pargv);
	    (*pargv)++;		/* forget the 'name' */
	    (*pargc)--;
	    return Ok;
	}
	else {
	    return Err;
	}
    }
}


/* convert an int into it's character representation */
char           *itoa(int i)
{
    char            tmp[MAX_CHAR_TMP];

    sprintf(tmp, "%d", i);
    return myStrDup(tmp);
}


/* concat a dirname and a basename in dst    */
/* dst is allocated by caller                */
/* try to be clever:                         */
/* - add a / if needed t                    */
/* /dev + null -> /dev/null             */
/* - don't concat if basename start with /  */
/* /dev + /null -> /null                */
void            concatPath(char *dst, char *dirname, char *basename)
{
    int             ldn;

    if (!(dirname && basename && dst))
	error("concatPath: one parameter is NULL!");
    if (basename[0] == '/')
	strcpy(dst, basename);
    else {
	ldn = strlen(dirname);
	strcpy(dst, dirname);
	if (dirname[ldn - 1] == '/')
	    strcpy(dst + ldn, basename);
	else {
	    dst[ldn] = '/';
	    strcpy(dst + ldn + 1, basename);
	}
    }
}




int             openPath(List * lPath, char *fileName, int flag)
{
    char            tmp[MAX_CHAR_TMP];
    int             i, openRes;

    char           *pathComp;

    for (i = 1; i <= lNbElts(lPath); i++) {
	pathComp = (char *) lFindNth(lPath, i);
	concatPath(tmp, pathComp, fileName);
	if (!access(tmp, F_OK)) {
	    openRes = open(tmp, flag);
	    return openRes;
	}
    }
    warn2("can't find file ", fileName);
    return -2;
}

/*       There is no standard library function that you can count on in
 * all environments for "napping" (the usual name for short
 * sleeps).  Some environments supply a "usleep(n)" function which
 * suspends execution for n microseconds.  If your environment
 * doesn't support usleep(), here are a couple of implementations
 * for BSD and System V environments.
 * 
 * The following code is adapted from Doug Gwyn's System V emulation
 * support for 4BSD and exploits the 4BSD select() system call.
 * Doug originally called it 'nap()'; you probably want to call it
 * "usleep()";
 */

int
Uusleep( usec )                            /* returns 0 if ok, else -1 */
    long                usec;           /* delay in microseconds */
{
    static struct                       /* `timeval' */
        {
            long        tv_sec;         /* seconds */
            long        tv_usec;        /* microsecs */
        }   delay;          /* _select() timeout */
    
    delay.tv_sec = usec / 1000000L;
    delay.tv_usec = usec % 1000000L;
    
    return select( 0, (long *)0, (long *)0, (long *)0, &delay );
}

void
UExtractSuffix(char * fileName, char *suffix)
{
    int sl,fl;
    fl=strlen(fileName);
    sl=strlen(suffix);
    if (!strcmp(fileName+(fl-sl),suffix)){
        *(fileName+(fl-sl))='\0';
    }
    else{
        UIWarning("UExtractSuffix");
    }
}


void
UAddSuffix(char * fileName, char *suffix)
{
    strcat(fileName,".");
    strcat(fileName,suffix);
}


void
UGetSuffix(char * fileName, char *suffix)
{
    char * pSep;

    *suffix='\0';
    pSep=strrchr(fileName,'.');
    if(pSep)
        strcpy(suffix,pSep+1);
    else
        *suffix='\0';
}
