#ifndef AGATGEN_H
#define AGATGEN_H

#define AGAT_ENV "AGAT"
#define PLAYBACKEXE "agatreplay"
#define DUMPSERVER  "agatdump"

#define ER_ENVVARNOTDEF "Can't find environment variable : "
#define ERS_UNKNOWN_STYP "Unknown structure type : "
#define ERS_UNKNOWN_VTYP "Unknown value type : "

#define MASK_VTYP 0x1f
#define MASK_STYP 0xe0
#define EXTRACT_VTYPE(typ) ((typ)&((unsigned char)MASK_VTYP))
#define EXTRACT_STYPE(typ) (((typ)&((unsigned char)MASK_STYP))>>5)
#define MELT_SVTYPE(stype,vtype) ((unsigned char)(((stype)<<5)|(vtype)))

#define STYP_TAB      1
#define STYP_SVAL     2

#define VTYP_CHAR     1
#define VTYP_SHORT    2
#define VTYP_INT      3
#define VTYP_LONG     4
#define VTYP_UCHAR    5
#define VTYP_USHORT   6
#define VTYP_UINT     7
#define VTYP_ULONG    8
#define VTYP_FLOAT    9
#define VTYP_DOUBLE  10

typedef short   Fid;

typedef struct SDescTab {
    int             nbElt;
    int             sz;
}               SDescTab;

typedef struct SDescStream {
    int             nameLen;
    Fid             fid;
}               SDescStream;

typedef struct MsgHeader {
    unsigned char   type;
    Fid             fid;
}               MsgHeader;



#define DEBUG

#endif
