#ifndef AGATCHECK_H
#define AGATCHECK_H
#include "myAll.h"
#include "agattypes.h"


/* the maximum number of errors before aborting */
#define MAX_ERROR_BEF_ABORT   20

/* size of chunks used during funProtos building (reallocation size) */
#define FP_CHKSZ 20
/* and postProcs building */
#define PP_CHKSZ 20

/* size of the hash-table used for include names storage */
#define HT_INC_SZ          20
#define HT_CONST_SZ        50
#define HT_MACRO_SZ        50
#define HT_STREAM_SZ       50
#define HT_FUNC_SZ         50
#define HT_POSTPROCFUNC_SZ 20

extern FADef   *allDef;
extern List    *lIncludePath;
extern HashTable *htInclude;
extern HashTable *htConst;
extern HashTable *htMacro;
extern HashTable *htStream;
extern HashTable *htFunc;
extern PostProc *postProcs;
extern int      postProcsNb;
extern Boolean  silentWarn;

/* functions used during the parsing  */

Boolean         compTypes(unsigned char t1, unsigned char t2);
void            parseError(char *msg);
void            checkError(char *file, int lgn, char *msg);
void            checkWarning(char *file, int lgn, char *msg);
int             nbFANames(FAName * lf);
void            addFunc(char *funcName, int arity, unsigned char parType, unsigned char retType, GenericFunc pFunc);
void            initFirstAnalysis(void);
void            endFirstAnalysis(void);
void            addDef(FADef * pd);
void            addInclude(char *ident);
void            addConst(char *file, int lgn, char *ident, FADef * pd);
void            addMacro(char *file, int lgn, char *ident, int nbArg, FADef * pd);
void            addStream(char *file, int lgn, char *ident, FADef * pd);
void            addPostProcFunc(char *funcName, int arity, unsigned char st, GenericFunc pInitFunc, GenericFunc pFunc);


/* for semantic check */
void            semaCheck(FADef * allDef);


#endif
